# This file contains all variables needed to run the bench 

# Choose among one of theses algorithms:
#
# For sequential emptiness check
#   Dijkstra                     : ecoptdijkstra-cs
#   Dijkstra + compressed stack  : ecoptdijkstra+cs
#   Tarjan                       : ecopttarjan-cs
#   Tarjan + compressed stack    : ecopttarjan+cs
#   NDFS + main optimisations    : ndfs
#   Tarjan Union-Find            : tuc13-cs
#   Tarjan Union-Find  + cs      : tuc13+cs
#   Dijkstra Union-Find          : uc13-cs
#   Dijkstra Union-Find + cs     : uc13+cs
#
# For decomposition emptiness check
#   Dijkstra decomposition          : tacas13dijkstra-cs
#   Dijkstra decomposition + cs     : tacas13dijkstra+cs
#   Tarjan decomposition            : tacas13tarjan-cs
#   Tarjan decomposition + cs       : tacas13tarjan+cs
#   NDFS decomposition              : tacas13ndfs
#   Tarjan Union-Find decomp.       : tacas13tuc13-cs
#   Tarjan Union-Find decomp. +cs   : tacas13tuc13+cs
#   Dijkstra Union-Find decomp. +cs : tacas13uc13-cs
#   Dijkstra Union-Find decomp. +cs : tacas13uc13+cs
#
# For parallel emptiness check
#   Dijkstra Parallel with X threads : concur_ec_dead_dijkstra-csX 
#   Mixed Parallel with X threads    : concur_ec_dead_mixed-csX
#   Tarjan Parallel with X threads   : concur_ec_dead_tarjan-csX

export ALGO=concur_ec_dead_dijkstra-cs12

# The path of the root directory
export ROOTPATH=/home/erenault/phd/$ALGO

# The path to the dve2check util
export DVE2CHECK=/home/erenault/phd/spot/iface/dve2fasttgba/dve2check

