#! /bin/sh

# source the file that contains paths 
echo Set up env...
BASEDIR=$(dirname $0)
source  $(pwd)/$BASEDIR/env.sh
cd $ROOTPATH

# Check wether the file must be replaced
replacedata=false
if [ -f $ROOTPATH/formula/data ]; then
    while true; do
	read -p "$ROOTPATH/formula/data exist. Erase [Y/n]?" yn
	case $yn in
            [Yy]* ) 
		replacedata=true;
		break;;
            [Nn]* )
		echo Continue with existing file : "$ROOTPATH/formula/data";
		break;;
            * ) echo "Please answer yes or no.";;
	esac
    done;
fi

if [ "$replacedata" = true ]; then 
    rm $ROOTPATH/formula/data

    # Merge all 
    echo Merge all traces..
    cat $ROOTPATH/formula/*.ltl > $ROOTPATH/formula/data-tmp

    # Construct the bench file
    SIZE=$(wc -l $ROOTPATH/formula/data-tmp | awk '{print $1}')
    echo Construct the bench master file [size = $SIZE]...
    for i in $(seq 1 "$SIZE"); do
	sed -n "$i"p $ROOTPATH/formula/data-tmp| tr "," " " |awk  '{for (i=1; i<=NF; i++) if (i == 1 || i == 2 || i > 16 ) printf $i" "}' >> $ROOTPATH/formula/data
	echo "" >> $ROOTPATH/formula/data
    done
    rm -f $ROOTPATH/formula/data-tmp

fi

# Create the all: rule for Makefile
echo Create main rule for Makefile..
MAKEFILE_ALL=
SIZE=$(wc -l $ROOTPATH/formula/data| awk '{print $1}')
for i in $(seq 1 "$SIZE"); do
    MAKEFILE_ALL="$MAKEFILE_ALL r$i.log"
done



echo "Create Makefile.. (it could take a while!)"
rm -f Makefile

cat > Makefile <<EOF
all: $MAKEFILE_ALL

EOF


for i in $(seq 1 "$SIZE"); do
    cat >> Makefile <<EOF

r$i.log:
	echo "#! /bin/bash" >  r$i.log-sh 
	awk -v q="'" -v talgo="-$ALGO" -v tool=" $DVE2CHECK " 'NR==$i {printf tool; printf q; for (i=3; i<=NF; i++) printf \$\$i " " ;printf q" "; printf "models/"\$\$1" "; print talgo" "; exit;  }' $ROOTPATH/formula/data  >> r$i.log-sh
	chmod a+x r$i.log-sh 
	bash ./r$i.log-sh > r$i.log-tmp
	mv r$i.log-tmp r$i.log
	rm r$i.log-sh
EOF
done

echo "" >> Makefile
for i in $(cat $ROOTPATH/formula/data | awk '{print $1}' | sort -u);do
    TMP=$(nl formula/data | grep "$i" | awk '{print $1}'  | sed -e 's/^/r/' -e 's/$/.log/' | tr "\n" " ")
    echo $i: $TMP >> Makefile
    echo "" >> Makefile
done


cat >> Makefile <<EOF

clean:
	rm -f *.log
EOF

exit 1

 


#DVE2CHECK=/lrde/home/renault/concur/spot/iface/dve2fasttgba/dve2check
RES=


cat <<EOF
all: $RES
EOF

for i in $(seq 1 "$SIZE"); do
    cat <<EOF

r$i.log:
	echo "#! /bin/bash" >  r$i.log-sh 
	awk -v q="'" -v tool=" $DVE2CHECK " 'NR==$i {printf tool; printf q; for (i=3; i<=NF; i++) printf \$\$i " " ;printf q" "; print "models/"\$\$1" -concur_dead_tarjan1"; exit;  }' leader-election.3.verified.data  >> r$i.log-sh
	awk -v q="'" -v tool=" $DVE2CHECK " 'NR==$i {printf tool; printf q; for (i=3; i<=NF; i++) printf \$\$i " " ;printf q" "; print "models/"\$\$1" -concur_dead_tarjan2"; exit;  }' leader-election.3.verified.data  >> r$i.log-sh
	awk -v q="'" -v tool=" $DVE2CHECK " 'NR==$i {printf tool; printf q; for (i=3; i<=NF; i++) printf \$\$i " " ;printf q" "; print "models/"\$\$1" -concur_dead_tarjan4"; exit;  }' leader-election.3.verified.data  >> r$i.log-sh
	awk -v q="'" -v tool=" $DVE2CHECK " 'NR==$i {printf tool; printf q; for (i=3; i<=NF; i++) printf \$\$i " " ;printf q" "; print "models/"\$\$1" -concur_dead_tarjan8"; exit;  }' leader-election.3.verified.data  >> r$i.log-sh
	awk -v q="'" -v tool=" $DVE2CHECK " 'NR==$i {printf tool; printf q; for (i=3; i<=NF; i++) printf \$\$i " " ;printf q" "; print "models/"\$\$1" -concur_dead_tarjan12"; exit;  }' leader-election.3.verified.data  >> r$i.log-sh
	chmod a+x r$i.log-sh 
	bash ./r$i.log-sh > r$i.log-tmp
	mv r$i.log-tmp r$i.log
	rm r$i.log-sh
EOF
done

cat <<EOF

clean:
	rm -f *.log
EOF
